#!/bin/sh

# Run vifreset if we detect that we are running under Xen, in case the
# kernel modules are too old to recover from an already-running vif
# device (left over from the iSCSI boot).
#
if [ -d /proc/xen ] ; then
    KVER=`uname -r`
    if [ -z "${KVER}" ] || [ "${KVER}" \< "3.0" ]; then
        echo "Detected XEN and old/unknown kernel (${KVER}), triggering vifreset"
    	modprobe xenfs
    	mount -t xenfs none /proc/xen

    	vifreset
	    echo "Sleeping after vifreset"
    	sleep 3
    	echo "Sleeping after vifreset is done"

    	umount /proc/xen
    fi
fi
